//!CompilerOption:Optimize:On


using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using System.Collections.Specialized;
using System.Runtime.InteropServices;

using CommonBehaviors.Actions;
using Levelbot.Actions.Combat;

using Styx;
using Styx.Helpers;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.POI;
using Styx.CommonBot.Routines;

using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.World;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;
using Action = Styx.TreeSharp.Action;


namespace Styx.Bot.CustomBots
{

    public partial class KeyBindBotBase : BotBase
    {
        public override string Name { get { return "KeyBindBotBase"; } }

        public static KeyBindBotBase Instance { get; private set; }
        public KeyBindBotBase() { Instance = this; }
        public override PulseFlags PulseFlags { get { return PulseFlags.All; } }
        LocalPlayer Me = StyxWoW.Me;
        static PrioritySelector luaFunBt;
        static WoWUnit CT = StyxWoW.Me.CurrentTarget;



        // put your initialization code in here..
        public override void Start()
        {
			luaFunBt = new PrioritySelector();
			// ********************* Start of Example ***************************
            Log("Adding Actions");

			//AddAction(ShamanAOE, Keys.D5);
			AddAction(DKUnholysingleRotation, Keys.D1);
            //AddAction(DKUnholymultiRotation, Keys.D3);
			// End of example
        }

        // this gets called on every plugin pulse.. like 13 times per sec, put your main code here
        public override void Pulse()
        {
        }
        public override TreeSharp.Composite Root
        {
            get
            {
                return luaFunBt ?? (luaFunBt = new PrioritySelector());
            }
        }

        // use this to add key bindable macros to list
        void AddAction(Composite comp, System.Windows.Forms.Keys vKey)
        {
            // first make sure that no other actions have same keybind
            if (luaFunBt.Children.Where(a =>
            {
                if (a is KeyBindDecorator)
                {
                    KeyBindDecorator ka = (KeyBindDecorator)a;
                    if (ka.KeyBind == vKey)
                        return true;
                }
                return false;
            }).Count() > 0)
            {
                throw new InvalidOperationException("A Macro exists with that Keybind");
            }
            luaFunBt.Children.Add(new KeyBindDecorator(vKey, comp));
        }
        
		// remove by index;
        void RemoveAction(int index)
        {
            if (index >= 0 && index < luaFunBt.Children.Count)
                luaFunBt.Children.RemoveAt(index);
        }
        
		// remove by keybind
        void RemoveAction(System.Windows.Forms.Keys vKey)
        {   // we need to use a for () since we can't add/delete while using foreach
            for (int i = 0; i < luaFunBt.Children.Count; i++)
            {
                if (luaFunBt.Children[i] is KeyBindDecorator)
                {
                    KeyBindDecorator ka = (KeyBindDecorator)luaFunBt.Children[i];
                    if (ka.KeyBind == vKey)
                    {
                        luaFunBt.Children.Remove(ka);
                        return;
                    }
                }
            }
        }

        void ThreadLoop()
        {
            Styx.Plugins.PluginContainer myPlugin;
            myPlugin = Styx.Plugins.PluginManager.Plugins.FirstOrDefault(p => p.Plugin.Name == this.Name);

            while (myPlugin.Enabled)
            {
                //StyxWoW.Update();
                Thread.Sleep(50);
                if (!luaFunBt.IsRunning)
                    luaFunBt.Start(null);
                luaFunBt.Tick(null);
            }
        }
		
        public static void Log(string format, params object[] args)
        {
            Logging.Write( "LuaKeyBotBase: " + format, args);
        }

        #region call Rotations
		public Composite DKUnholysingleRotation
        {
            get
            {
               // return new Decorator(r => StyxWoW.Me.CurrentTarget != null && Target.Attackable && !Me.Mounted, PVPRotation);
			   return new Decorator(r => StyxWoW.Me.CurrentTarget != null , DKUnholysingleRota);
            }
        }
		
		public Composite DKUnholysingleRota
        {
            get
            {
                return new PrioritySelector(
						new Action(r => { Log("this awesome Keybind Action has been triggerd PVPRotationTest"); return RunStatus.Failure; })
                        // new Decorator(r => !Me.IsAutoAttacking, new Action(r => Me.ToggleAttack())),
                        // new Decorator(r => Manual, new PrioritySelector(
                        // CreateFaceTargetBehavior(ret => Me.CurrentTarget),
                        // CreateMoveToMeleeBehavior(true),
                        // new Decorator(r => Me.CurrentTarget.IsDead, new Action(r => Me.ClearTarget())),
                        // PVPSealCheck
                        // )),
                        
                        // PVPCooldowns,
						// CanThenDo(r => CanCast("Judgment"), "Judgment"),
                        // CanThenDo(r => CanCast("Exorcism"), "Exorcism"),
                        // CanThenDo(r => CanCast("Crusader Strike"), "Crusader Strike")
                        // CanThenDo(r => CanCast("Rebuke") && VanguardSettings.Instance.PVPKick && Me.CurrentTarget.IsCasting && Me.CurrentTarget.CanInterruptCurrentSpellCast, "Rebuke"),

                        // CanThenDo(r => CanCast("Hammer of Justice") && ((VanguardSettings.Instance.PVPKick && Me.CurrentTarget.IsCasting && VanguardSettings.Instance.PVPHammer == PVPStun.Casting) || VanguardSettings.Instance.PVPHammer == PVPStun.Cooldown), "Hammer of Justice"),
                        // new Decorator(r => VanguardSettings.Instance.UseEngi && Me.Inventory.Equipped.Hands != null &&
                        // Me.Inventory.Equipped.Hands.Cooldown <= 0 && (Target.Distance <= 6 || Target.IsWithinMeleeRange), new Action(r => { Me.Inventory.Equipped.Hands.Use(); return RunStatus.Failure; })),

                         // CanThenDo(r => !VanguardSettings.Instance.PVPDisableInq && (!isAuraActive("Inquisition") || (isAuraActive("Inquisition") && Me.ActiveAuras["Inquisition"].TimeLeft.TotalSeconds <= VanguardSettings.Instance.PVPInquisitionTime)) && CanCast("Inquisition") && Me.CurrentHolyPower >= VanguardSettings.Instance.PVPInquisitionHP, "Inquisition"),
                         // TV(5),
                         // CanThenDoAtTarget(r => CanCast("Execution Sentence"), "Execution Sentence"),
                         // CastOnGround(r => CanCast("Light's Hammer") && PVPLightsHammer, "Light's Hammer", r => Target.Location),
                         // CanThenDo(r => CanCast("Hammer of Wrath") && (Target.HealthPercent <= 20.0f || isAuraActive("Avenging Wrath")), "Hammer of Wrath"),
                         // CanThenDo(r => CanCast("Exorcism"), "Exorcism"),
                         // CanThenDo(r => CanCast("Crusader Strike"), "Crusader Strike"),
                        // CanThenDo(r => CanCast("Judgment"), "Judgment"),
                        // TV(3)
                        );
            }
        }


        #endregion

		#region Combat utils
        Composite PVPCooldowns
        {
            get
            {
                return new PrioritySelector(
                    new Decorator(r => '1'=='1',
                        new PrioritySelector(
                            CanThenDoGCD(r => CanCast("Guardian of Ancient Kings") && CanCast("Avenging Wrath") && (!SpellManager.HasSpell("Holy Avenger") || CanCast("Holy Avenger")), "Guardian of Ancient Kings"),
                            CanThenDoGCD(r => SpellManager.HasSpell("Guardian of Ancient Kings") && CdLeft("Guardian of Ancient Kings") <= 290 && CdLeft("Guardian of Ancient Kings") > 0 && CanCast("Avenging Wrath"), "Avenging Wrath"),
                            CanThenDoGCD(r => SpellManager.HasSpell("Guardian of Ancient Kings") && CdLeft("Guardian of Ancient Kings") <= 290 && CdLeft("Guardian of Ancient Kings") > 0 && CanCast("Holy Avenger"), "Holy Avenger")


                            )),

                   new Decorator(r => '1'=='1',
                        new PrioritySelector(
                            CanThenDoGCD(r => CanCast("Guardian of Ancient Kings"), "Guardian of Ancient Kings"),
                            CanThenDoGCD(r => CanCast("Avenging Wrath"), "Avenging Wrath"),
                            CanThenDoGCD(r => CanCast("Holy Avenger"), "Holy Avenger")


                            ))
                    );
            }
        }		
		
		
		
		
		
		
		
		Composite PVPSealCheck
        {
            get
            {
                return new PrioritySelector(
                    CanThenDo(r => CanCast("Seal of Command") && !Me.HasAura("Seal of Command"), "Seal of Command"),
                    CanThenDo(r => CanCast("Seal of Truth") && !Me.HasAura("Seal of Truth"), "Seal of Truth"));
            }
        }

        Composite TV(int hp)
        {

            return new Decorator(r => Me.CurrentHolyPower >= hp,CanThenDo(r => CanCast("Templar's Verdict"), "Templar's Verdict")); // 

        }

        bool PVPLightsHammer
        {
            get
            {
                return UnfriendlyUnitsNearTarget(10f) >= 2 && SpellManager.HasSpell("Light's Hammer");// && VanguardSettings.Instance.Hotr;
            }
        }
		
		private bool CleanseTime()
        {


            if (Me.ManaPercent < 20)
                return false;

            if (Me.CurrentTarget != null)
            {
                if (Me.CurrentTarget.Distance < 5)
                {
                    return false;
                }
            }

            int Debuffs = Cleanse.Count(isAuraActive);


            return Debuffs <= 2 && Debuffs != 0;
        }
				
		
        Composite CanThenDo(CanRunDecoratorDelegate CanWe, string Spell)
        {
            return new Decorator(CanWe, CastSpell(Spell));
        }

        Composite CanThenDoAtUnit(CanRunDecoratorDelegate CanWe, string Spell, UnitSelectionDelegate unit)
        {
            return new Decorator(CanWe, CastSpell(Spell, unit));
        }


        Composite CanThenDoAtTarget(CanRunDecoratorDelegate CanWe, string Spell)
        {
            return new Decorator(CanWe, CastSpell(Spell,r=>Target));
        }

        Composite CanThenDoGCD(CanRunDecoratorDelegate CanWe, string Spell)
        {
            return new Decorator(CanWe, CastSpellGCD(Spell));
        }

        Composite CastSpell(string Spell)
        {
            return new Action(r =>
            {
                Log(Spell);
                SpellManager.Cast(Spell);
            });
        }

        Composite CastSpell(string Spell, UnitSelectionDelegate Who)
        {
            return new Action(z =>
                                  {
                                      WoWUnit unit = Who(z);
                                      Log(Spell + "@" + unit);
                                      SpellManager.Cast(Spell, unit);
            });
        }

        Composite CastSpellGCD(string Spell)
        {
            return new Action(r =>
            {
                Log(Spell);
                SpellManager.Cast(Spell);
                return RunStatus.Failure;
            });
        }


        bool isAuraActive(string Spell)
        {
            return StyxWoW.Me.ActiveAuras.ContainsKey(Spell);
        }


        bool CanCast(string Name)
        {
            return SpellManager.CanCast(Name);
        }


        double CdLeft(string name)
        {
            return SpellManager.Spells[name].CooldownTimeLeft.TotalSeconds;
        }



        public delegate WoWUnit UnitSelectionDelegate(object context);
        public delegate WoWPoint LocationRetriever(object context);
        public delegate float DynamicRangeRetriever(object context);

        public delegate bool SimpleBooleanDelegate(object context);



        public Composite CastOnGround(SimpleBooleanDelegate requirements, string spell, LocationRetriever onLocation)
        {
            return
                new Decorator(
                    ret =>
                    requirements(ret) && onLocation != null && SpellManager.CanCast(spell) &&
                    (StyxWoW.Me.Location.Distance(onLocation(ret)) <= SpellManager.Spells[spell].MaxRange ||
                     SpellManager.Spells[spell].MaxRange == 0) && GameWorld.IsInLineOfSpellSight(StyxWoW.Me.Location, onLocation(ret)),
                    new Sequence(
                        new Action(ret => Log("Casting {0} at location {1}", spell, onLocation(ret))),
                        new Action(ret => SpellManager.Cast(spell)),

                        new DecoratorContinue(ctx => false,
                            new WaitContinue(1,
                                ret =>
                                StyxWoW.Me.CurrentPendingCursorSpell != null &&
                                StyxWoW.Me.CurrentPendingCursorSpell.Name == spell, new ActionAlwaysSucceed())),

                        new Action(ret => SpellManager.ClickRemoteLocation(onLocation(ret)))));
        }

        public static float MeleeRange
        {
            get
            {
                // If we have no target... then give nothing.
                // if (StyxWoW.Me.CurrentTargetGuid == 0)  // chg to GotTarget due to non-zero vals with no target in Guid
                if (!StyxWoW.Me.GotTarget)
                    return 0f;

                if (StyxWoW.Me.CurrentTarget.IsPlayer)
                    return 3.5f;

                return  Math.Max(5f, StyxWoW.Me.CombatReach + 1.3333334f + StyxWoW.Me.CurrentTarget.CombatReach);
            }
        }		

        public static Composite CreateWaitForLagDuration()
        {
            return new WaitContinue(TimeSpan.FromMilliseconds((StyxWoW.WoWClient.Latency * 2) + 150), ret => false, new ActionAlwaysSucceed());
        }

        private WoWUnit Target
        {
            get { return StyxWoW.Me.CurrentTarget; }
        }

		public int UnfriendlyUnitsNearTarget(float distance)
        {
            var dist = distance * distance;

            if (StyxWoW.Me.CurrentTarget == null)
                return -1;



            var curTarLocation = StyxWoW.Me.CurrentTarget.Location;
            return ObjectManager.GetObjectsOfType<WoWUnit>(false, false).Count(p => p.Entry != 53889 && ValidUnit(p) && UnitInRange(p));


        }
		
		private String[] Cleanse = new String[]
                                       {
                                           "Blast Wave", "Aftermath", "Concussive Shot", "Slow", "Infected Wounds",
                                           "Freeze", "Frost Nova", "Piercing Howl", "Earthgrab", "Entangling Roots",
                                           "Frost Shock", "Entrapment", "Chains of Ice", "Chilled", "Shattered Barrier",
                                           "Cone of Cold", "Frostbolt","Net"
                                       };
		
		static bool ValidUnit(WoWUnit p)
        {
            // Ignore shit we can't select/attack
            if (!p.CanSelect || !p.Attackable)
                return false;

            // Ignore friendlies!
            if (p.IsFriendly)
                return false;

            // Duh
            if (p.IsDead)
                return false;


            // If its a pet, lets ignore it please.
            //if (p.IsPet || p.OwnedByRoot != null)
            //    return false;

            // And ignore critters/non-combat pets
            if (p.IsNonCombatPet || p.IsCritter)
                return false;


            return true;
        }
		
		 private bool UnitInRange(WoWUnit possible)
        {   // Find the distance between the centers.
            float dx = Me.CurrentTarget.X - possible.X;
            float dy = Me.CurrentTarget.Y - possible.Y;

            var radius0 = 10;
            var radius1 = possible.CombatReach;

            double dist = Math.Sqrt(dx * dx + dy * dy);

            // See how manhym solutions there are.
            if (dist > radius0 + radius1)
            {
                // No solutions, the circles are too far apart.
                return false;
            }

            return true;
        }
		
		
		#endregion
	//######################################################################################################################################################	
		
        #region Decorator

        public class DecoratorContinueEx : DecoratorContinue
        {
            protected new CanRunDecoratorDelegate Runner { get; private set; }

            public DecoratorContinueEx(CanRunDecoratorDelegate func, Composite decorated)
                : base(decorated)
            {
                Runner = func;
            }

            protected override bool CanRun(object context)
            {
                if (!StyxWoW.IsInGame || StyxWoW.Me.NotValid())
                    return false;

                return Runner != null ? Runner(context) : base.CanRun(context);
            }
        }
        #endregion




	
}

    #region KeyBindDecorator
    public class KeyBindDecorator : Decorator
    {
        [DllImport("user32.dll")]
        static extern short GetAsyncKeyState(System.Windows.Forms.Keys vKey);
        [DllImport("user32.dll")]
        static extern IntPtr GetForegroundWindow();
        //public static IntPtr _wowHandle = StyxWoW.WoWProcess.MainWindowHandle;
		private static readonly IntPtr _wowHandle = StyxWoW.Memory.Process.MainWindowHandle;

        public System.Windows.Forms.Keys _keyBind;
        // these modifer bools are true if our keybind uses them. otherwise false.
        public bool _shiftkey = false;
        public bool _ctrlkey = false;
        public bool _altkey = false;

        public KeyBindDecorator(Keys keybind, Composite child)
            : base(child)
        {
            // k holds both modifer and  key so we need to extract the modifer
            _shiftkey = (keybind & Keys.Shift) != 0 ? true : false;
            _ctrlkey = (keybind & Keys.Control) != 0 ? true : false;
            _altkey = (keybind & Keys.Alt) != 0 ? true : false;
            // now we remove the modifer flags from k and assign it to _keybind.
            _keyBind = (~Keys.Modifiers) & keybind;
        }
        public System.Windows.Forms.Keys KeyBind
        {
            get { return _keyBind; }
            set
            {   // check for modifer flags 
                _shiftkey = (value & Keys.Shift) != 0 ? true : false;
                _ctrlkey = (value & Keys.Control) != 0 ? true : false;
                _altkey = (value & Keys.Alt) != 0 ? true : false;
                // remove modifer bits
                _keyBind = (~Keys.Modifiers) & value;
            }
        }

        public static bool IsKeyDown(System.Windows.Forms.Keys vKey)
        {
            return (GetAsyncKeyState(vKey) != 0);
        }

        public bool PollKeys()
        {   // checks button status and returns true if our beybind is pressed.
            if (IsKeyDown(_keyBind) && (!(_shiftkey ^ IsKeyDown(Keys.ShiftKey))) &&
                (!(_ctrlkey ^ IsKeyDown(Keys.ControlKey))) && (!(_altkey ^ IsKeyDown(Keys.Menu))))
            {
                return true;
            }
            return false;
        }

        protected override bool CanRun(object context)
        {
            // if keybind is pressed and our wow window is the currently active window then execute macro
            IntPtr fgWinHwnd = GetForegroundWindow();
            if (PollKeys() && _wowHandle == fgWinHwnd)
			//if (PollKeys())
            {
                Logging.Write("{0} pressed: Executing Action", KeyBind);
                return true;
            }
            else
                return false;
        }
    }
    #endregion

    static class MyExtensions
    {
        public static bool Valid(this WoWObject unit)
        {
            return unit != null && unit.IsValid;
            //return StyxWoW.IsInGame && unit != null && unit.BaseAddress != 0;
        }

        public static bool NotValid(this WoWObject unit)
        {
            return !StyxWoW.IsInGame || unit == null || unit.BaseAddress.ToInt32() == 0;
        }
    }
}